/*
 * A mini transition relation postfix reader
 * ---
 * January 2002
 * to my angel
 */

#ifndef _BDD_H_
#define _BDD_H_

/* print modes */
#define BDD_PRINT_TEXT		0
#define BDD_PRINT_IMAGE		1
#define BDD_PRINT_MINTERM	2

typedef void bdd;
typedef void manager;

#include "vars.h"

typedef struct {
  bdd **list;
  variable *list2;
  bdd *cube;
  int size;
  int maxsize;
} bdd_variables_set;

typedef struct {
  manager *manager;
} bdd_data;

#include <stdio.h>

#include "trans.h"
#include "vars.h"

int init_bdd(bdd_data *);
void free_bdd(bdd_data *);
bdd *bdd_new_variable(bdd_data *);
bdd_variables_set *new_bdd_variables_set(void);
void free_bdd_variables_set(bdd_data *, bdd_variables_set *);
void bdd_variables_set_add(bdd_variables_set *, variable, bdd *);
void bdd_update_variables_set(bdd_data *, bdd_variables_set *);

void set_variables_set_type(variables *, bdd_variables_set *, int);
void canonize_variables(variables *, bdd_variables_set *, bdd_variables_set *, bdd_variables_set *, bdd_variables_set *);

bdd *transition_tree_to_bdd(bdd_data *, trans_data *, variables *, transition_tree);
void bdd_print(bdd_data *, variables *, bdd *, int);

bdd *bdd_get_successors(bdd_data *, bdd *, bdd *, bdd_variables_set *, bdd_variables_set *, bdd_variables_set *);
bdd *bdd_get_predecessors(bdd_data *, bdd *, bdd *, bdd_variables_set *, bdd_variables_set *, bdd_variables_set *);
bdd *bdd_get_one_state(bdd_data *, bdd *, bdd **, int);
bdd *bdd_or(bdd_data *, bdd *, bdd *);
bdd *bdd_xor(bdd_data *, bdd *, bdd *);
bdd *bdd_and(bdd_data *, bdd *, bdd *);
bdd *bdd_not(bdd_data *, bdd *);
bdd *bdd_one(bdd_data *);
bdd *bdd_zero(bdd_data *);

int bdd_is_zero(bdd_data *, bdd *);

bdd *bdd_array_to_bdd(bdd_data *, char *, int);

#endif /* _BDD_H_ */
