/* bmc
 * read "Symbolic Model Checking using SAT procedures instead of BDDs"
 * to get the stuff
 *--
 * public domain
 * may 2002
 */

#ifndef _BMC_H_
#define _BMC_H_

#include "trans.h"
#include "vars.h"
#include "bdd.h"
#include "ctl.h"

transition_tree Mk(trans_data *, variables *, transition_tree, transition_tree, int);
transition_tree Lk(trans_data *, variables *, transition_tree, int);
transition_tree lLk(trans_data *, variables *, transition_tree, int, int);
transition_tree translate_ltl(trans_data *, variables *, ctl_data *, ctl_formula, int, int);
transition_tree translate_ltl_loop(trans_data *, variables *, ctl_data *, ctl_formula, int, int, int);

ctl_formula negate_ltl_formula(ctl_data *, ctl_formula);
void print_modified_tree(trans_data *, variables *, transition_tree, bdd_variables_set *);

#include "clauses.h"

unsigned long to_cnf(clauses *, trans_data *, transition_tree);
void dump_variable_names(trans_data *, transition_tree, variables *, bdd_variables_set *);

/* special cases : G xx where xx doesn't have temporal stuff
 *                 F xx same definition of xx
 */
#include "checker.h"

int isG(ctl_data *, ctl_formula);
int isF(ctl_data *, ctl_formula);
transition_tree onlyG(checker *, int);
transition_tree onlyF(checker *, int);

#endif /* _BMC_H_ */
