/*
 * A mini transition relation postfix reader
 * ---
 * January 2002
 * to my angel
 */

#ifndef _CHECKER_H_
#define _CHECKER_H_

#include "bdd.h"
#include "vars.h"
#include "trans.h"
#include "ctl.h"

#define TYPE_CTL	0
#define TYPE_LTL	1

typedef struct _checker {
  bdd_data bdd_data;
  variables variables;
  trans_data trans_data;
  ctl_data ctl_data;
  bdd_variables_set *vars;
  bdd_variables_set *varsnext;
  bdd_variables_set *varsinput;
  bdd_variables_set *varsoutput;
  bdd *f, *init_states;
  transition_tree f_trans, init_states_trans;
  ctl_formula formula;
  int formula_type;
  /* fairness data */
  ctl_formula *fairness;	/* the array of fairness constraints as ctl formula */
  bdd **fairness_bdd;		/* bdds of states validating the above ctl formulas */
  int nbmax_fairness;
  int nb_fairness;
  char *filename;
  int we_do;
} checker;

/* what does the user want to do ? */
#define WE_DO_NOTHING		-1
#define WE_DO_CHECK		 0
#define WE_DO_NEXTSTATE		 1
#define WE_DO_ACCESS_GRAPH	 2
#define WE_DO_BMC		 3

int init_checker(checker *, char *, int);
void close_checker(checker *);
int check(checker *);

void print_tree(trans_data *, variables *, transition_tree);
void print_tree_n(trans_data *, variables *, transition_tree);

#endif /* _CHECKER_H_ */
