/*
 * clauses definition
 *----
 * May(day ?) 2002
 * public domain
 */

#include "clauses.h"

#include <string.h>
#include <stdio.h>

#include "mem.h"

/* returns -1 if pb, 0 if all ok */
int init_clauses(clauses *c)
{
  memset(c, 0, sizeof(clauses));

  return 0;
}

void free_clauses(clauses *c)
{
#if 0
  int i;

  for (i=0; i<c->size; i++)
    if (c->data[i].maxsize)
      freemem(c->data[i].data);
#endif

  freemem(c->data);

  memset(c, 0, sizeof(clauses));
}

clause *new_clause(clauses *c)
{
  if (c->size == c->maxsize)
    c->data = regetmem(c->data, (c->maxsize=c->maxsize?c->maxsize*2:256) * sizeof(clause));

  //memset(&c->data[c->size], 0, sizeof(clause));

  c->data[c->size].size = 0;

  c->size++;

  return &c->data[c->size-1];
}

void add_atom(clause *c, long v)
{
  if (c->size == 4) {
    //c->data = regetmem(c->data, (c->maxsize+=4) * sizeof(long));
    fprintf(stderr, "error ! 4 clauses !! impossible !\n");
    exit(0);
  }

  c->data[c->size] = v;

  c->size++;
}

static void dump_clause(clause *c)
{
  int i;

  for (i=0; i<c->size; i++)
    fprintf(stdout, "%ld ", c->data[i]);

  fprintf(stdout, "0\n");
}

void dump_clauses(clauses *c)
{
  int i;

  for(i=0; i<c->size; i++)
    dump_clause(&c->data[i]);
}
