/*
 * A hash table - more or less generic
 *---
 * to my angel
 * public domain
 * march 2002
 */

#ifndef _HASH2_H_
#define _HASH2_H_

/* flag values */
#define	HASH2_NO_ERROR		0
#define HASH2_OUT_OF_MEMORY	1
#define HASH2_ALREADY_PRESENT	2
#define HASH2_ALREADY_FREE	3
#define HASH2_NOT_PRESENT	4

/* must be power of 2 */
#define HASH2_INIT_SIZE_SMALL	4096
#define HASH2_INIT_SIZE_BIG	(256 * 1024)

typedef struct {
  unsigned long tree;
  unsigned long op;
  unsigned long l, r;
} elem;

typedef struct {
  /* data for the hash table */
  elem *data;
  unsigned char *data_busy;
  int flag;
  unsigned long size;
  unsigned long maxsize;
  unsigned long hash_collision;
  unsigned long hash_random;
} hash2_table;

#define hash2_get_elem_size(h) ((h)->elem_size)

/* functions for hash table manipulation */
#define get_hash_node(ht, h) ((ht)->data[h].tree)
void init_hash2(hash2_table *, int);
void free_hash2(hash2_table *);
unsigned long hash2_get_new_slot(hash2_table *, unsigned long, unsigned long, unsigned long);
//hid2 hash2_get_slot(hash2_table *, new_data *);
void hash2_feed_slot(hash2_table *, unsigned long, unsigned long, unsigned long, unsigned long, unsigned long);

/* functions for hash value calculation */
void hash2_start(hash2_table *);
void hash2_update(hash2_table *, void *, unsigned long);
unsigned long hash2_end(hash2_table *);
unsigned long hash2_simple(hash2_table *, void *, unsigned long);

#endif /* _HASH2_H_ */
