#include <png.h>
#include <stdio.h>
#include <stdlib.h>

int colors[][3] = {
{132, 130, 132},
{198, 195, 198},
{0, 0, 255},
{0, 130, 0},
{255, 0, 0},
{0, 0, 132},
{132, 0, 0},
{0, 130, 132},
{132, 0, 132},
{0, 0, 0},
{255, 255, 255},
{-1, -1, -1}
};

int get_color(int r, int g, int b)
{
  int i=0;

  while(colors[i][0] != -1) {
    if (colors[i][0] == r && colors[i][1] == g && colors[i][2] == b)
      return i;
    i++;
  }

  fprintf(stderr, "color not existing %d %d %d\n", r, g, b);
  abort();
}

int main(int n, char **v)
{
  unsigned char *p;
  int i, j;
  char buf[8];
  FILE *f;
  png_structp s;
  png_infop t, u;
  png_bytep *rows;

  if (n!=3) {
    fprintf(stderr, "give <a png file> <the data output name>\n");
    return 1;
  }

  f = fopen(v[1], "rb");
  if (!f) {
    perror(v[1]);
    return 1;
  }

  if (fread(buf, 1, 8, f)!=8)
    goto error;
  if (png_sig_cmp(buf, 0, 8) != 0) {
    fprintf(stderr, "not a png\n");
    goto error;
  }

  s = png_create_read_struct(PNG_LIBPNG_VER_STRING, 0, 0, 0);
  if (!s)
    goto error;
  t = png_create_info_struct(s);
  if (!t)
    goto error2;
  u = png_create_info_struct(s);
  if (!u)
    goto error3;

  png_init_io(s, f);
  png_set_sig_bytes(s, 8);

  png_read_png(s, t, PNG_TRANSFORM_IDENTITY, 0);
  rows = png_get_rows(s, t);
  if (!rows)
    goto error4;

  fprintf(stdout, "unsigned char %s[] = {\n", v[2]);
  for (j=0; j<16; j++) {
    p = rows[j];
    for (i=0; i<16; i++, p+=3)
      fprintf(stdout, "%d, ", get_color(p[0], p[1], p[2]));
  }
  fprintf(stdout, "\n};\n");

  png_destroy_read_struct(&s, &t, &u);

  fclose(f);
  return 0;

error4:
  png_destroy_read_struct(&s, &t, &u);
  goto error;

error3:
  png_destroy_read_struct(&s, &t, 0);
  goto error;

error2:
  png_destroy_read_struct(&s, 0, 0);

error:
  fclose(f);
  fprintf(stderr, "an error occured\n");

  return 1;
}
