/*
 * A mini transition relation postfix reader
 * ---
 * January 2002
 * to my angel
 */

#ifndef _TRANS_H_
#define _TRANS_H_

/* those are defined in ctl.h */
#if 0
#ifndef OR
#define OR	xx
#endif
#ifndef AND
#define AND	xx
#endif
#ifndef NOT
#define NOT	xx
#endif
#endif

#define EQUAL	0x100
#define VAR	0x200

#include "vars.h"
#include "hash2.h"

/* trans_tree stuff */
typedef unsigned long transition_tree;

typedef struct {
  int op;
  int number;
  int added;
  int x, y, wire_line;
  union {
    struct {
      variable variable;
      /* used by bmc to get the position of the var in the path */
      /* must be -1 everywhere else (new_transition_tree_var does it for you) */
      int pos;
    } op_var;
    struct {
      transition_tree s;
    } op_one;
    struct {
      transition_tree l;
      transition_tree r;
    } op_two;
  } val;
} _transition_tree;

typedef struct {
  _transition_tree *trans_tree;
  int size;
  int maxsize;
  hash2_table ht;
} trans_data;

#define get_transition_tree_type(d, t) ((d)->trans_tree[t].op)
#define set_transition_tree_type(d, t, v) (d)->trans_tree[t].op = v
#define get_transition_tree_variable(d, t) ((d)->trans_tree[t].val.op_var.variable)
#define set_transition_tree_variable(d, t, v) (d)->trans_tree[t].val.op_var.variable = v
#define get_transition_tree_variable_pos(d, t) ((d)->trans_tree[t].val.op_var.pos)
#define set_transition_tree_variable_pos(d, t, p) (d)->trans_tree[t].val.op_var.pos = p
#define get_transition_tree_left_son(d, t) ((d)->trans_tree[t].val.op_two.l)
#define set_transition_tree_left_son(d, t, v) (d)->trans_tree[t].val.op_two.l = v
#define get_transition_tree_right_son(d, t) ((d)->trans_tree[t].val.op_two.r)
#define set_transition_tree_right_son(d, t, v) (d)->trans_tree[t].val.op_two.r = v
#define get_transition_tree_son(d, t) ((d)->trans_tree[t].val.op_one.s)
#define set_transition_tree_son(d, t, v) (d)->trans_tree[t].val.op_one.s = v

#define TRANS_UNDEF	0x80000000
#define trans_undef(x) ((x) == TRANS_UNDEF)

#include <stdio.h>

transition_tree new_transition_tree_var(trans_data *, variable);
transition_tree new_transition_tree_var2(trans_data *, variable, int);
transition_tree new_transition_tree_op(trans_data *, int, transition_tree, transition_tree);
transition_tree new_transition_tree_true(trans_data *);
transition_tree new_transition_tree_false(trans_data *);
void free_transition_tree(trans_data *, transition_tree);
int init_trans(trans_data *);
void free_trans(trans_data *);

void fsm_restart(FILE *);
int fsm_parse(void);
void fsm_lexer_close(void);
extern unsigned long fsm_linenumber;
int fsm_lex(void);
void fsm_error(const char *, ...);

#endif /* _TRANS_H_ */
