/*
 * A mini transition relation postfix reader
 * ---
 * January 2002
 * to my angel
 */

#ifndef _VARS_H_
#define _VARS_H_

#include "strings.h"

#define VARIABLE_TYPE_NO_TYPE	0
#define VARIABLE_TYPE_CURRENT	1
#define VARIABLE_TYPE_NEXT	2
#define VARIABLE_TYPE_INPUT	3
#define VARIABLE_TYPE_OUTPUT	4

typedef int variable;

typedef struct {
  int type;
  variable canonik_variable;
} info_type;

typedef struct {
  strings strings;
  sid *tab;
  void **tab_assoc;
  info_type *type;
  int size;
  int maxsize;
} variables;

#define NO_VARIABLE	(-1)

int init_vars(variables *);
void free_vars(variables *);

#define get_variable_names(x) ((char **)((x)->strings.data))
char *get_variable_name(variables *, variable);

variable get_variable(variables *, char *);

void *get_variable_assoc(variables *, variable);
void set_variable_assoc(variables *, variable, void *);

void set_variable_type(variables *, variable, int);
int get_variable_type(variables *, variable);

void set_variable_canon(variables *, variable, variable);
variable get_variable_canon(variables *, variable);

int new_variable(variables *, char *);

#endif /* _VARS_H_ */
